#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>

#include "shared/sockets.h"
#include "shared/debug.h"

#include "main.h"
#include "mode.h"
#include "echolink.h"

#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif

#ifdef HAVE_SYS_PARAM_H
#include <sys/param.h>
#endif

#ifdef HAVE_SYS_CPUVAR_H
#include <sys/cpuvar.h>
#endif

#ifdef HAVE_LIBKSTAT
#include <kstat.h>
#endif

#if HAVE_ERRNO_H
#include <errno.h>
#endif

#if HAVE_LIMITS_H
#include <limits.h>
#endif

#if HAVE_KVM_H
#include <kvm.h>
#endif

#if HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif

#if HAVE_SYS_PARAM_H
#include <sys/param.h>
#endif

#if HAVE_SYS_SYSCTL_H
#include <sys/sysctl.h>
#endif

#if HAVE_SYS_SCHED_H
#include <sys/sched.h>
#endif

#if HAVE_SYS_DKSTAT_H
#include <sys/dkstat.h>
#endif

//int load_fd = 0;
char connectednode[7];
int echo_connecttime = 0;
int echo_totconnect = 0;
int connecthrs;
int connectmins;
char *node;
                                                                                                        
int echo_init () {
    node = getenv("ECHO_MYCALL");
    return 0;
}

int echo_close () {
//    if (load_fd)
//        close (load_fd);
//    load_fd = 0;

    return 0;
}

//////////////////////////////////////////////////////////////////////////
// EchoLink Status screen
//
int echo_screen (int rep, int display) {
#undef IRLP_BUF_SIZE
#define IRLP_BUF_SIZE 4
//    int i, j, n;
    FILE *enable;		// File pointer to node enable flag
    FILE *active;		// File pointer to node active flag
    static int first = 1;

    if (first) {
        first = 0;
        //
        // Things that need to be written to the screen once get
        // written to the screen here.
        //
        sock_send_string (sock, "screen_add I\n");
        sprintf (buffer, "screen_set I -name {echo: %s}\n", host);
        sock_send_string (sock, buffer);
//        if (lcd_hgt >= 4) {
// DEVNOTE: If it is desired to use 20x4 displays, add the here
//        } else {
            sock_send_string (sock, "widget_add I line1 string\n");
            sock_send_string (sock, "widget_add I line2 string\n");
            sock_send_string (sock, "widget_add I nstat string\n");
            sprintf (buffer, "widget_set I line1 1 1 {NODE %s}\n", node+3);
            sock_send_string (sock, buffer);
//        }
        return 0;
    }
    enable = fopen("/home/irlp/local/echo_enable","r");
    if (enable==NULL) {
        sock_send_string (sock, "widget_set I nstat 11 1 { DISABLED }\n");
        sock_send_string (sock, "widget_set I line2 1 2 {                    }\n");
        echo_connecttime = 0;
    } else {
        fclose(enable);
        active=fopen("/home/irlp/local/echo_active", "r");
        if (active==NULL) {
            sock_send_string (sock, "widget_set I nstat 11 1 {   IDLE   }\n");
            sock_send_string (sock, "widget_set I line2 1 2 {                    }\n");
            echo_connecttime = 0;
        } else {
            sock_send_string (sock, "widget_set I nstat 11 1 {CONNECTED }\n");
            fgets(connectednode,  8, active);
            fclose(active);
            if (echo_connecttime==0)
                echo_connecttime=time(NULL);
            echo_totconnect=time(NULL)-echo_connecttime;
            connecthrs=echo_totconnect/3600;
            echo_totconnect=echo_totconnect%3600;
            connectmins=echo_totconnect/60;
            echo_totconnect=echo_totconnect%60;
            sprintf(buffer, "widget_set I line2 1 2 { %s  %02d:%02d:%02d }\n",
                connectednode, connecthrs,connectmins, echo_totconnect);
            sock_send_string (sock, buffer);
        }
    }
    return 0;
}  // End echo_screen()

