/*
 * This file contains status-gathering code *and* modescreen functions.
 * It's long, and messy.
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/utsname.h>
#include <string.h>

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#if defined( IRIX ) || defined( SOLARIS )
# include <strings.h>
#endif

#include "shared/sockets.h"

#include "mode.h"
#include "main.h"


#include "irlp.h"
#include "nmc.h"
#include "irlp.c"
#include "nmc.c"
#include "echolink.c"
#include "echolink.h"
#include "irlpdev.c"
#include "irlpdev.h"

int ELLIPSIS = '-';

// TODO: Clean this up...  Support multiple display sizes..

char buffer[1024];
char host[16];

void reread (int f, char *errmsg);
int getentry (const char *tag, const char *bufptr);

int mode_init (mode * sequence)
{
 int i;
 struct utsname Uname;

 // Grab the host name
 if (0 > uname (&Uname)) {
  perror ("Can't get hostname");
  strcpy (host, "host");
 } else {
  strncpy (host, Uname.nodename, 15);
  host[16] = 0;
  if (index (host, '.'))   // truncate at the first dot
   *(index (host, '.')) = '\0';
  for (i = 0; i < 16; i++)
   if (host[i] == '\n')
    host[i] = 0;
 }

 // Init all the modescreens we need
 for (i = 0; sequence[i].which > 1; i++) {
  switch (sequence[i].which) {
  case 'e':
  case 'E':
   echo_init ();
   break;
  case 'i':
  case 'I':       // IRLP screen
   irlp_init ();
   break;
  case 'n':
  case 'N':       // NMC screen
   nmc_init ();
   break;
  case 'a':
  case 'A':       // credit_screen
   break;
  default:
   break;
  }
 }

 return 0;
}

void
mode_close ()
{
 irlp_close ();
        nmc_close ();
}

int
update_screen (mode * m, int display)
{
 static int status = -1;
 int old_status = status;

 if (m) {
  switch (m->which) {
  case 'e':
  case 'E':
   status = echo_screen (m->timer, display);
   break;
  case 'i':
  case 'I':
   status = irlp_screen (m->timer, display);
   break;
  case 'n':
  case 'N':
   status = nmc_screen (m->timer, display);
   break;
  case 'a':
  case 'A':
   status = credit_screen (m->timer, display);
			break;
		default:
			break;
		}
		/* Debugging tool...
		   if(display)
		   {
		   printf("Displayed Mode %c\n", m->which);
		   }
		 */
	}

	if (status != old_status) {
		if (status == BACKLIGHT_OFF) {
			sock_send_string (sock, "backlight off\n");
		}
		if (status == BACKLIGHT_ON) {
			sock_send_string (sock, "backlight on\n");
		}
		if (status == BLINK_ON) {
			sock_send_string (sock, "backlight blink\n");
		}
	}
	return status;

}

void
reread (int f, char *errmsg)
{
	if (lseek (f, 0L, 0) == 0 && read (f, buffer, sizeof (buffer) - 1) > 0)
		return;
	perror (errmsg);
	exit (1);
}

int
getentry (const char *tag, const char *bufptr)
{
	char *tail;
	int retval, len = strlen (tag);

	while (bufptr) {
		if (*bufptr == '\n')
			bufptr++;
		if (!strncmp (tag, bufptr, len)) {
			retval = strtol (bufptr + len, &tail, 10);
			if (tail == bufptr + len)
				return -1;
			else
				return retval;
		}
		bufptr = strchr (bufptr, '\n');
	}
	return -1;
}

///////////////////////////////////////////////////////////////////////////
//////////////////////// Let the Modes Begin! /////////////////////////////
///////////////////////////////////////////////////////////////////////////

// Er, these have been moved..  :)

char tmp[1024];

////////////////////////////////////////////////////////////////////////
// Credit Screen shows who wrote this...
//
int
credit_screen (int rep, int display)
{
	static int first = 1;

 if (first) {
  first = 0;

  sock_send_string (sock, "screen_add A\n");
  sock_send_string (sock, "screen_set A -name {Credits for IRLP-LCD}\n");
  sock_send_string (sock, "widget_add A title title\n");
  sprintf (tmp, "widget_set A title {IRLP-LCD}\n");
  sock_send_string (sock, tmp);
  if (lcd_hgt >= 4) {
   sock_send_string (sock, "widget_add A one scroller\n");
   sock_send_string (sock, "widget_add A two scroller\n");
   sock_send_string (sock, "widget_add A three scroller\n");
   sock_send_string (sock, "widget_set A one 1 2 20 2 v 8 {                       based on LCDproc }\n");
   sock_send_string (sock, "widget_set A two 1 3 20 3 v 8 { by Christopher Hart by William Ferrell }\n");
   sock_send_string (sock, "widget_set A three 1 4 20 4 v 8 { and Randy Hammock   and Scott Scriven}\n");
  } else {
   sock_send_string (sock, "widget_add A text scroller\n");
   sock_send_string (sock, "widget_set A text 1 2 20 2 h 1 { by Christoher Hart and Randy Hammock, based on LCDproc by William Ferrell and Scott Scriven}\n");
  }
 }

 return 0;
}            // End credit_screen()
